"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const isISerializable_1 = __importDefault(require("./isISerializable"));
class Serializable {
    constructor() {
        this.toObject = () => {
            const obj = lodash_1.default.omitBy(this, (item) => {
                return lodash_1.default.isFunction(item);
            });
            const ret = lodash_1.default.mapValues(obj, (value) => {
                if (isISerializable_1.default(value)) {
                    return value.toObject();
                }
                return value;
            });
            return lodash_1.default.toPlainObject(ret);
        };
    }
}
exports.default = Serializable;
//# sourceMappingURL=Serializable.js.map